// TODO:
// + check entered values in settingsdialog
// + check if using doublebuffer 
// + store agents' position into statistics too energy_level, x, y, dir
// ? some algaes are drawn over others
// + selection of agents causes some confusing selections
// + because of some badly used indices, exception occures if width!=height
// - nullpointer-exception if simulation-windows is closed and simulation running

// + light world has some strange behaviour
// + debug output shows wrong agent# (+1)
// + agent sensors don't turn into the right direction with the agent
// + a new agent's thingys aren't calculated in the step he's born
// + flags for an agent like born, died,... aren't set correctly for stats

import algae.simulation.*;
import algae.simulation.BatchWC;
import algae.simulation.GUIWC;
import algae.gui.SettingsDialog;

import algae.xmlstuff.SettingsImport;
import algae.xmlstuff.SettingsExport;

public final class Main {	
 
     static Settings cfg;
     static SettingsImport sImport;
     
     public static void main(String s[])
     {
     	   sImport=new SettingsImport();
     	   // if parameter is given, in fact a settingsfile,
     	   // we start the batch mode
	   if ((s.length>0))
	   {
	       cfg = new Settings();
	       
	       if (sImport.importSettingsFile(s[0])==null)
		   return;

	       BatchWC wc=new BatchWC(cfg,s[0]+".stat");
	      
	       wc.run();	       
	   }  
	   // otherwise go on with the gui
	   else
	   {
	       SettingsDialog sdlg=new SettingsDialog();
	       sdlg.setTitle("Settings dialog");
	       sdlg.setVisible(true);
	       sdlg.setSize(400,350);
	       sdlg.setResizable(true);
	       sdlg.pack();
	   }
     }	
}
