package algae.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.BorderFactory;
import javax.swing.border.*;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

import java.io.*;
import java.util.*;
import java.lang.Number;
import java.lang.Float;
import java.lang.*;

public final class InfoWin extends JFrame implements ActionListener {

    Container contentPane = getContentPane();

    String dirStrings[];

    JLabel Dummy1=new JLabel("Direction:");
    JLabel DirLabel=new JLabel("---");

    JLabel Label0 = new JLabel("ANN-Output:");
    JLabel ANNOutputLabel = new JLabel("0");
    
    JLabel Label1=new JLabel("Energy:");
    JLabel EnergyLabel=new JLabel("0");
    JProgressBar EnergyProg = new JProgressBar(0,100);
    
    JLabel Label2=new JLabel("LightR:");
    JLabel LightLabel1=new JLabel("0");
    JProgressBar LightProg1 = new JProgressBar(0,100);
    JLabel Label3=new JLabel("LightB:");
    JLabel LightLabel2=new JLabel("0");
    JProgressBar LightProg2 = new JProgressBar(0,100);
    JLabel Label4=new JLabel("LightL:");
    JLabel LightLabel3=new JLabel("0");
    JProgressBar LightProg3 = new JProgressBar(0,100);
    JLabel Label5=new JLabel("LightF:");
    JLabel LightLabel4=new JLabel("0");
    JProgressBar LightProg4 = new JProgressBar(0,100);
    
    JLabel Label6=new JLabel("SubstrateR:");
    JLabel SubstLabel1=new JLabel("0");
    JProgressBar SubstProg1 = new JProgressBar(0,100);
    JLabel Label7=new JLabel("SubstrateB:");
    JLabel SubstLabel2=new JLabel("0");
    JProgressBar SubstProg2 = new JProgressBar(0,100);
    JLabel Label8=new JLabel("SubstrateL:");
    JLabel SubstLabel3=new JLabel("0");
    JProgressBar SubstProg3 = new JProgressBar(0,100);
    JLabel Label9=new JLabel("SubstrateF:");
    JLabel SubstLabel4=new JLabel("0");
    JProgressBar SubstProg4 = new JProgressBar(0,100);
    
    JLabel Label10=new JLabel("PheromoneR:");
    JLabel PheroLabel1=new JLabel("0");
    JProgressBar PheroProg1 = new JProgressBar(0,100);
    JLabel Label11=new JLabel("PheromoneB:");
    JLabel PheroLabel2=new JLabel("0");
    JProgressBar PheroProg2 = new JProgressBar(0,100);
    JLabel Label12=new JLabel("PheromoneL:");
    JLabel PheroLabel3=new JLabel("0");
    JProgressBar PheroProg3 = new JProgressBar(0,100);
    JLabel Label13=new JLabel("PheromoneF:");
    JLabel PheroLabel4=new JLabel("0");
    JProgressBar PheroProg4 = new JProgressBar(0,100);
    
    JLabel Label14=new JLabel("BumperR:");
    JLabel BumperLabel1=new JLabel("0");
    JProgressBar BumperProg1 = new JProgressBar(0,100);
    JLabel Label15=new JLabel("BumperB:");
    JLabel BumperLabel2=new JLabel("0");
    JProgressBar BumperProg2 = new JProgressBar(0,100);
    JLabel Label16=new JLabel("BumperL:");
    JLabel BumperLabel3=new JLabel("0");
    JProgressBar BumperProg3 = new JProgressBar(0,100);
    JLabel Label17=new JLabel("BumperF:");
    JLabel BumperLabel4=new JLabel("0");
    JProgressBar BumperProg4 = new JProgressBar(0,100);
    
    JPanel content = new JPanel();
    JPanel BottomPanel = new JPanel();

    JButton OKBtn = new JButton("OK");

    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();

    public InfoWin(){
	addWindowListener(new WindowAdapter() 
        {
	    public void windowClosing(WindowEvent e) 
	    {
		setVisible(false);
            }
        });

	dirStrings=new String[4];
	dirStrings[0]="Right";
	dirStrings[1]="Down";
	dirStrings[2]="Left";
	dirStrings[3]="Up";

	contentPane=getContentPane();
	contentPane.setLayout(gridbag);
	contentPane=getContentPane();

	BottomPanel.add(OKBtn,BorderLayout.CENTER);
	OKBtn.addActionListener(this);

	content.setLayout(new GridLayout(10,4));
	
	content.add(Label1);
	content.add(EnergyLabel);
	//content.add(EnergyProg);
	content.add(new JLabel(""));
	content.add(new JLabel(""));
	
	content.add(Label0);
	content.add(ANNOutputLabel);
	
	content.add(Dummy1);
	content.add(DirLabel);

	content.add(Label2);
	//content.add(LightProg1);
	content.add(LightLabel1);    
	content.add(Label3);
	//content.add(LightProg2);
	content.add(LightLabel2);    
	content.add(Label4);
	//content.add(LightProg3);
	content.add(LightLabel3);    
	content.add(Label5);
	//content.add(LightProg4);
	content.add(LightLabel4);    
 
	content.add(Label6);
	//content.add(SubstProg1);
	content.add(SubstLabel1);    
	content.add(Label7);
	//content.add(SubstProg2);
	content.add(SubstLabel2);    
	content.add(Label8);
	//content.add(SubstProg3);
	content.add(SubstLabel3);    
	content.add(Label9);
	//content.add(SubstProg4);
	content.add(SubstLabel4);    

	content.add(Label10);
	//content.add(PheroProg1);
	content.add(PheroLabel1);    
	content.add(Label11);
	//content.add(PheroProg2);
	content.add(PheroLabel2);    
	content.add(Label12);
	//content.add(PheroProg3);
	content.add(PheroLabel3);    
	content.add(Label13);
	//content.add(PheroProg4);
	content.add(PheroLabel4);    
 
	content.add(Label14);
	//content.add(BumperProg1);
	content.add(BumperLabel1);    
	content.add(Label15);
	//content.add(BumperProg2);
	content.add(BumperLabel2);    
	content.add(Label16);
	//content.add(BumperProg3);
	content.add(BumperLabel3);    
	content.add(Label17);
	//content.add(BumperProg4);
	content.add(BumperLabel4);    
	
	c.gridx = 0;
        c.gridy = 0;
        c.gridwidth=23;
        c.gridheight=12;
        c.weightx=1;
        c.weighty=1;
        c.insets=new Insets(2,2,2,2);
        c.fill = GridBagConstraints.BOTH;
        gridbag.setConstraints(content, c);
        contentPane.add(content);

	c.gridx = 0;
        c.gridy = 12;
        c.gridwidth=23;
        c.gridheight=2;
        c.weightx=1;
        c.weighty=0;
        c.insets=new Insets(2,2,2,2);
        c.fill = GridBagConstraints.NONE;
        gridbag.setConstraints(BottomPanel, c);
        contentPane.add(BottomPanel);
   }

    public void setValues(float val[], int sel)
    {
    	this.setTitle("Agent "+sel);
    	
	DirLabel.setText(dirStrings[(int)val[0]-1]);
	EnergyLabel.setText(Float.toString(val[1]));

	LightLabel1.setText(Float.toString(val[2]));
   	LightLabel2.setText(Float.toString(val[3]));
   	LightLabel3.setText(Float.toString(val[4]));
   	LightLabel4.setText(Float.toString(val[5]));

	SubstLabel1.setText(Float.toString(val[6]));
	SubstLabel2.setText(Float.toString(val[7]));
	SubstLabel3.setText(Float.toString(val[8]));
	SubstLabel4.setText(Float.toString(val[9]));
	
	PheroLabel1.setText(Float.toString(val[10]));
	PheroLabel2.setText(Float.toString(val[11]));
	PheroLabel3.setText(Float.toString(val[12]));
	PheroLabel4.setText(Float.toString(val[13]));

	BumperLabel1.setText(Float.toString(val[14]));
	BumperLabel2.setText(Float.toString(val[15]));
	BumperLabel3.setText(Float.toString(val[16]));
	BumperLabel4.setText(Float.toString(val[17]));	
	
	ANNOutputLabel.setText(Integer.toString((int)val[18]));
    }
    
    public void clearValues()
    {
    	this.setTitle("Agent <none selected>");
    	
	DirLabel.setText("-----");
	EnergyLabel.setText("-----");
	
	ANNOutputLabel.setText("----");

	LightLabel1.setText("-----");
   	LightLabel2.setText("-----");
   	LightLabel3.setText("-----");
   	LightLabel4.setText("-----");

	SubstLabel1.setText("-----");
	SubstLabel2.setText("-----");
	SubstLabel3.setText("-----");
	SubstLabel4.setText("-----");
	
	PheroLabel1.setText("-----");
	PheroLabel2.setText("-----");
	PheroLabel3.setText("-----");
	PheroLabel4.setText("-----");

	BumperLabel1.setText("-----");
	BumperLabel2.setText("-----");
	BumperLabel3.setText("-----");
	BumperLabel4.setText("-----");	
    }

   public void actionPerformed(ActionEvent e)
        {
	    Object src=e.getSource();
	    if (src==OKBtn)
	    {
		this.setVisible(false);
	    }
	} 
}
